<template functional>
  <section
    :ref="data.ref"
    class="flex flex-col items-stretch"
    :class="[
      { 'lg:flex-row': !props.reversed },
      { 'lg:flex-row-reverse': props.reversed },
      data.class,
      data.staticClass,
    ]"
    :style="[data.style, data.staticStyle]"
    v-bind="data.attrs"
    v-on="listeners"
  >
    <!-- Cover Image -->
    <div
      class="cover h-screen-50 sm:h-screen-70 lg:h-auto lg:w-1/2"
      :class="[
        {
          'fx-overlay fx-ovl-color':
            props.overlay.color || props.overlay.opacity,
        },
      ]"
      :style="{
        '--fx-overlay-color': props.overlay.color,
        '--fx-overlay-opacity': props.overlay.opacity,
      }"
    >
      <g-image
        :src="props.coverImage.image"
        :alt="props.coverImage.description"
        class="h-full w-full object-cover"
        :class="[
          { 'object-left': !props.reversed },
          { 'object-right': props.reversed },
        ]"
      />
    </div>

    <!-- Cover Content -->
    <div
      class="content relative flex flex-col justify-center lg:w-1/2"
      :class="[{ 'lg:items-center': props.centered }]"
    >
      <article class="xl:max-w-3xl">
        <header v-if="slots().heading">
          <slot name="heading" />
        </header>

        <div v-if="slots().default" class="mt-8 lg:mt-10">
          <slot />
        </div>
      </article>

      <footer
        v-if="slots().bottom"
        class="xl:absolute xl:bottom-0 xl:max-w-2xl"
      >
        <slot name="bottom" />
      </footer>
    </div>
  </section>
</template>

<script>
export default {
  name: 'CoverSplitSection',
  props: {
    coverImage: {
      type: Object,
      default: () => ({ image: undefined, description: undefined }),
      required: true,
    },
    overlay: {
      type: Object,
      default: () => ({ color: undefined, opacity: undefined }),
    },
    reversed: { type: Boolean, default: false },
    centered: { type: Boolean, default: false },
  },
};
</script>

<style lang="postcss" scoped>
@screen lg {
  .cover {
    min-height: calc(100vh - var(--g-navbar-h));
  }
}

.content {
  --content-px: var(--g-px);
  --content-py: var(--g-py);

  padding: var(--content-py) var(--content-px);
}
@screen sm {
  .content {
    --content-px: var(--g-px-sm);
    --content-py: var(--g-py-sm);
  }
}
@screen md {
  .content {
    --content-px: var(--g-px-md);
    --content-py: var(--g-py-md);
  }
}
@screen lg {
  .content {
    --content-px: var(--g-px-lg);
    --content-py: var(--g-py-lg);
  }
}
@screen xl {
  .content {
    --content-px: var(--g-px-xl);
    --content-py: var(--g-py-xl);
  }
}
</style>
